#PrinterLib_Include=1
XIncludeFile "Printer_Lib.pb"

Global Max.l
Global idx.l
Global Zoom.l

Procedure Showimage()
  Protected img
  SetGadgetText(6,Str(idx+1)+"/"+Str(max))
  SetGadgetText(8,"Zoom "+Str(Zoom)+"%")
  img=Print_GetPreviewImage(idx)
  If img
    SetGadgetState(1,ImageID(img))
  EndIf
EndProcedure

Procedure Print_Preview(Preview)
  Protected pw,xa,ya,Text$
  Protected Dim vert.TRIVERTEX(4)
  Protected Dim gTri.GRADIENT_TRIANGLE(1)

  Print_OpenPrinter("","PAPERSIZE="+Str(#DMPAPER_A4)+",ORIENTATION="+Str(#DMORIENT_PORTRAIT))
  
  If Preview=#True
    pw=(450*Zoom)/100
    Print_StartPreview(pw)
    xa=Print_GetDeviceCaps(#HORZRES)+20
    ya=Print_GetDeviceCaps(#VERTRES)+20
    SetGadgetAttribute(0,#PB_ScrollArea_InnerWidth,xa)
    SetGadgetAttribute(0,#PB_ScrollArea_InnerHeight,ya)
  Else
    Print_StartPrinting("TEST")
  EndIf
  
  ; Start preview
    Print_SetTextColor(#Red)
    Print_Font("Arial",48)
    Text$="Print Lib Test Page"
    Print_Text(20,20,Text$)
    
    vert(0)\x       =  Print_ConvertUnitsToPointsX(20)
    vert(0)\y       =  Print_ConvertUnitsToPointsY(50)
    vert(0)\Red     =  $0000
    vert(0)\Green   =  $FF00
    vert(0)\Blue    =  $0000
    vert(0)\Alpha   =  $0000
    vert(1)\x       =  Print_ConvertUnitsToPointsX(120)
    vert(1)\y       =  Print_ConvertUnitsToPointsY(50)
    vert(1)\Red     =  $0000
    vert(1)\Green   =  $FF00
    vert(1)\Blue    =  $FF00
    vert(1)\Alpha   =  $0000
    vert(2)\x       =  Print_ConvertUnitsToPointsX(120)
    vert(2)\y       =  Print_ConvertUnitsToPointsY(150)
    vert(2)\Red     =  $FF00
    vert(2)\Green   =  $0000
    vert(2)\Blue    =  $FF00
    vert(2)\Alpha   =  $FF00
    vert(3)\x       =  Print_ConvertUnitsToPointsX(20)
    vert(3)\y       =  Print_ConvertUnitsToPointsY(150)
    vert(3)\Red     =  $FF00
    vert(3)\Green   =  $0000
    vert(3)\Blue    =  $0000
    vert(3)\Alpha   =  $0000
    gTRi(0)\Vertex1 = 0
    gTRi(0)\Vertex2 = 1
    gTRi(0)\Vertex3 = 2
    gTRi(1)\Vertex1 = 0
    gTRi(1)\Vertex2 = 2
    gTRi(1)\Vertex3 = 3
    Print_GradientFill(@vert(0),4,@gTRi(0),1,#GRADIENT_FILL_TRIANGLE)
    
    vert(0)\x      = Print_ConvertUnitsToPointsX(20)
    vert(0)\y      = Print_ConvertUnitsToPointsY(160)
    vert(0)\Red    = $0000
    vert(0)\Green  = $0000
    vert(0)\Blue   = $0000
    vert(0)\Alpha  = $0000
    vert(1)\x      = Print_ConvertUnitsToPointsX(20+50)
    vert(1)\y      = Print_ConvertUnitsToPointsX(160+50)
    vert(1)\Red    = $0000
    vert(1)\Green  = $0000
    vert(1)\Blue   = $FF00
    vert(1)\Alpha  = $FF00
    Dim gRect.GRADIENT_RECT(2)
    gRect(0)\UpperLeft  = 0
    gRect(0)\LowerRight = 1
    Print_GradientFill(@vert(0),2,@gRect(0),1,#GRADIENT_FILL_RECT_H)
    vert(0)\x      = Print_ConvertUnitsToPointsX(20+60)
    vert(0)\y      = Print_ConvertUnitsToPointsY(160)
    vert(1)\x      = Print_ConvertUnitsToPointsX(20+50+60)
    vert(1)\y      = Print_ConvertUnitsToPointsX(160+50)
    Print_GradientFill(@vert(0),2,@gRect(0),1,#GRADIENT_FILL_RECT_V)
    
  ; Preview end
  If Preview=#True
    Print_StopPreview()
  Else
    Print_StopPrinting()
  EndIf
  max=Print_GetPreviewCount()
  Showimage()
EndProcedure

Procedure Button_First()
  idx=0
  Showimage()
EndProcedure

Procedure Button_Left()
  If idx>0
    idx-1
  EndIf
  Showimage()
EndProcedure

Procedure Button_Right()
  If idx<(max-1)
    idx+1
  EndIf
  Showimage()
EndProcedure

Procedure Button_Last()
  If max>0
    idx=max-1
  Else
    idx=max
  EndIf
  Showimage()
EndProcedure

Procedure Button_Zoom()
  Select Zoom
    Case 100
      Zoom=150
    Case 150
      Zoom=200
    Case 200
      Zoom=300
    Case 300
      Zoom=400
    Case 400
      Zoom=500
    Case 500
      Zoom=800
    Case 800
      Zoom=100
  EndSelect
  
  Print_Preview(#True)
  Showimage()
EndProcedure

If OpenWindow(0,0,0,500,720,"Test",#PB_Window_SystemMenu)
  ScrollAreaGadget(0,10,10,480,680, 470, 670, 30)
  ImageGadget(1,10,10,480,680,0)
  CloseGadgetList()
  ButtonGadget(2,10,695,20,20,"|<")
  ButtonGadget(3,30,695,20,20,"<")
  ButtonGadget(4,50,695,20,20,">")
  ButtonGadget(5,70,695,20,20,">|")
  TextGadget(6,100,695,40,20,"0/0",#PB_Text_Border)
  ButtonGadget(7,150,695,40,20,"Print")
  ButtonGadget(8,200,695,70,20,"Zoom 100%")
EndIf

Define event
idx=0
Zoom=100
Print_Preview(#True)
Showimage()

Repeat
  event=WaitWindowEvent()
  Select event
    Case #PB_Event_Gadget
      If EventType()=#PB_EventType_LeftClick
        Select EventGadget()
          Case 2
            Button_First()
          Case 3
            Button_Left()
          Case 4
            Button_Right()
          Case 5
            Button_Last()
          Case 7
            Print_Preview(#False)
          Case 8
            Button_Zoom()
        EndSelect
      EndIf
  EndSelect
Until event=#PB_Event_CloseWindow
; IDE Options = PureBasic 4.61 (Windows - x86)
; CursorPosition = 158
; FirstLine = 129
; Folding = --